var messageArray = new Array("ALM","ATT","CRT","DCR","DDS","DPO","DTM","GGA","GLL","GNS", "GRS","GSA","GST","GSV","HDT","LTN","POS","PTT","RMC","RRE","SAT", "SGA", "SGL", "SGP", "TTT","VEC","VTG", "XDR", "ZDA");
var portArray = new Array("A","B","F","C","E","I","P","Q","M","U", "R" );

var theNmeaMessagesTableView = null;
var currentStatus = null;

function getNmeaMessagesSource() {
	if (currentStatus != null)
	{
		var portName = getResource('portArrayLabel').split(",");
		
		for (i in currentStatus.NmeaMessage) {		
			for (j in portArray) {
				if (portArray[j] == currentStatus.NmeaMessage[i].Port) {
					currentStatus.NmeaMessage[i].Output = portName[j];
				}
			}
			
			//There is no null messages within JSON but XDR & PTT & TTT
			//Therefore, theses lines are useless
			if (currentStatus.NmeaMessage[i].Message != "XDR" && 
				currentStatus.NmeaMessage[i].Message != "PTT" && 
				currentStatus.NmeaMessage[i].Message != "TTT" && 
				currentStatus.NmeaMessage[i].Rate == null) {
				currentStatus.NmeaMessage[i].Rate = currentStatus.NmeaDefaultRate;
			}
			
			if (currentStatus.NmeaMessage[i].Rate != null) {
				var rate = currentStatus.NmeaMessage[i].Rate + "";
				if (rate.indexOf(" s") == -1) {
					rate += " s";
					currentStatus.NmeaMessage[i].Rate = rate;
				}
			}
		}
		
		return currentStatus.NmeaMessage;
	}
	else return [];
}

function updateStatusNmeaMessage()
{
	// Define the callbacks for the asyncRequest
	var callbacks = {
		
		success : function (o) {

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try {
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x) {
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry to update
				setTimeout("updateStatusNmeaMessage()", 5000);

				return;
			}
			
			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));			
			
			// Get status
			var status = data.StatusNmeaMessage;
			if (status == null) return;
			
			// -- Update current status --
			currentStatus = status;
			
			if (theNmeaMessagesTableView == null)
			{
				theNmeaMessagesTableView = new NmeaMessagesTableView( getNmeaMessagesSource );
			}
			
			setTimeout("updateStatusNmeaMessage()", 5000);
		},

		failure : function (o) {
			if (!YAHOO.util.Connect.isCallInProgress(o)) {
				YAHOO.log("ERROR: Async call failed!");
			}
			
			// Retry to update
			setTimeout("updateStatusNmeaMessage()", 5000);
		},

		timeout : 10000,
		cache : false
	};

	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET',getStatusNmeaMessageURL, callbacks);
}

function NmeaMessagesTableView(source) {
	
	// Columns definition
	var myColumnDefs = 
	[
		{label:getResource('Nmea-Table-Resource-Port'), key:"Port", resizeable:true, className: "centered"},
		{label:getResource('Nmea-Table-Resource-Output'), key:"Output", resizeable:true},
		{label:getResource('Nmea-Table-Resource-Message'), key:"Message", resizeable:true},
		{label:getResource('Nmea-Table-Resource-Rate'), key:"Rate", resizeable:true}
	];
	
	// Fields
	var baseFields = ["Port", "Output", "Message", "Rate"];
	
	// Data source
	var myDataSource = new YAHOO.util.DataSource(source);
	myDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
	myDataSource.responseSchema = {
		fields: ["Port", "Output", "Message", "Rate"]
	};
	
	// Table configs
	var myConfigs = {
		width:"auto",
		caption:getResource('Nmea-Table-Resource-NMEA')
	};
	
	// Localized messages
	myConfigs.MSG_EMPTY = getResource('Nmea-Table-Resource-Empty');
	myConfigs.MSG_LOADING = getResource('Nmea-Table-Resource-Loading');
	
	// Create table
	var myDataTable = new YAHOO.widget.DataTable('NmeaMessagesTableView', myColumnDefs, myDataSource, myConfigs);
	
	var recordSet = myDataTable.getRecordSet();
	for (j = 0; j < recordSet.getLength(); j++){
		var record = recordSet.getRecord(j);
		
		if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
			var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
			var tds = trEl.getElementsByTagName("td");
			for (k = 0; k < tds.length; k++)
				tds[k].style.borderTop = '1px solid #000000';
		}
	}
	
	// Set up polling
	var myCallback =
	{
		success: function()
		{
			var myDataTable = new YAHOO.widget.DataTable('NmeaMessagesTableView', myColumnDefs, myDataSource, myConfigs);
			
			var recordSet = myDataTable.getRecordSet();
			for (j = 0; j < recordSet.getLength(); j++){
				var record = recordSet.getRecord(j);
				
				if ((j > 0) && (record.getData("Port") != recordSet.getRecord(j - 1).getData("Port"))) {
					var trEl = myDataTable.getTrEl(recordSet.getRecordIndex(record));
					var tds = trEl.getElementsByTagName("td");
					for (k = 0; k < tds.length; k++)
						tds[k].style.borderTop = '1px solid #000000';
				}
			}
		},
		failure: function()
		{
			YAHOO.log("NmeaMessagesTableView: Polling failure", "error");
		},
		scope: myDataTable
	};
	myDataSource.setInterval(5000, null, myCallback);
}
